package org.hornetq.jms.example;

import java.util.Date;
import java.util.Hashtable;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class Consumer1 implements MessageListener {

	public static String name = "Consumer-1";

	public static void main(String[] args) throws NamingException, JMSException {
		System.out.println("start " + name);
		InitialContext initialContext = null;
		Connection connection = null;
		try {
			Hashtable<String, String> env = new Hashtable<String, String>();
			env.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
			env.put(Context.PROVIDER_URL, "jnp://localhost:1099");
			env.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");

			initialContext = new InitialContext(env);

			Queue queue = (Queue) initialContext.lookup("/queue/testQ");

			ConnectionFactory cf = (ConnectionFactory) initialContext.lookup("/ConnectionFactory");

			connection = cf.createConnection();

			Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);

			MessageConsumer consumer1 = session.createConsumer(queue);
			consumer1.setMessageListener(new Consumer1(name));
			connection.start();
			// Just wait a long time
			Thread.sleep(12000000);
		} catch (Exception e) {
			e.printStackTrace();
		} finally {

			if (initialContext != null) {
				initialContext.close();
			}
			if (connection != null) {
				connection.close();
			}
		}

		System.out.println("end " + name);

	}

	public Consumer1(final String listenerName) {
		name = listenerName;
	}

	public void onMessage(final Message message) {
		try {
			TextMessage msg = (TextMessage) message;
			System.out.format(new Date().toString() + "Message: [%s] received by %s\n", msg.getText(), name);

		} catch (JMSException e) {
			e.printStackTrace();
		}
	}
}
